// -*- c-basic-offset: 2; related-file-name: "filter.C" -*-
/*
 * @(#)$Id: filter.h,v 1.5.4.2 2006/01/27 23:41:54 tcondie Exp $
 * 
 * This file is distributed under the terms in the attached LICENSE file.
 * If you do not find this file, copies can be found by writing to:
 * Intel Research Berkeley, 2150 Shattuck Avenue, Suite 1300,
 * Berkeley, CA, 94704.  Attention:  Intel License Inquiry.
 * Or
 * UC Berkeley EECS Computer Science Division, 387 Soda Hall #1776, 
 * Berkeley, CA,  94707. Attention: P2 Group.
 * 
 * DESCRIPTION: Element that drops tuples according to a simple boolean
 * predicate.  The predicate field must be of type INT32. 0 drops while
 * any other INT32 value keeps the field.  A non-INT32 field or the
 * absence of the field drops the tuple.
 */

#ifndef __FILTER_H__
#define __FILTER_H__

#include "element.h"

class Filter : public Element { 
public:

  Filter(string, unsigned);

  /** Overridden to perform the filtering. */
  TuplePtr simple_action(TuplePtr p);

  const char *class_name() const		{ return "Filter";}
  const char *processing() const		{ return "a/a"; }
  const char *flow_code() const			{ return "x/x"; }


private:
  /** My filter field number.*/
  unsigned _filterNo;
};


#endif /* __FILTER_H_ */
